/* Copyright (c) 2003 Macromedia Inc. $Revision: 1.9 $ */
function parseCookies() {
	var cookieObject = new Object();
	var cookieArr = document.cookie.split(';');
	for (i=0; i<cookieArr.length; i++) {
		thisVal = cookieArr[i];
		valArr = thisVal.split('=');
		cookieObject[valArr[0]] = valArr[1];
	}
	return cookieObject;
}
function getCookie (name) {
	if (cookies == null) cookies = parseCookies();
	var value = new String();
	for (key in cookies) {
		if (key.toUpperCase().match(name)) {
			value = unescape(cookies[key]);
			break;
		}
	}
	return value;
}
Dimensions = function (w,h) { 
	this.width = w || 0;
	this.height = h || 0;
	return this;
}
XYCoords = function (x,y) { 
	this.x = x || 0;
	this.y = y || 0;	
	return this;
}
BoxCoords = function (x1,y1,x2,y2) {
	this.x1 = x1 || 0;
	this.y1 = y1 || 0;
	this.x2 = x2 || 0;
	this.y2 = y2 || 0;
	return this;
}
function getEventCoords (e) {
	var coords = new XYCoords();
	if (e.pageX && e.pageY) {	
		coords.x = e.pageX;
		coords.y = e.pageY;	
	} else if (e.clientX && e.clientY) {	
		coords.x = e.clientX + document.body.scrollLeft;
		coords.y = e.clientY + document.body.scrollTop;
	}
	return coords;
}	
function getElementBoxCoords(domElement) {
	this.element = domElement;
	this.calculated_offset;
	this.calcOffsetFrom = function (element,from,reset) {
		if (reset != false) this.calculated_offset = 0;
		if (element != null)	{
			switch (from) {
				case 'top': 
					this.calculated_offset += element.offsetTop;
					break;
				case 'left': 
					this.calculated_offset += element.offsetLeft;
					break;
			}
			if ((element.offsetParent == document.body) || (element.offsetParent.tagName == ('HTML'||'BODY'))) {				
				return this.calculated_offset;
			} else {
				return this.calcOffsetFrom(element.offsetParent,from,false);
			}
		}
	}
	this.w = this.element.offsetWidth;
	this.h = this.element.offsetHeight;
	var coords = new BoxCoords();
	coords.x1 = this.calcOffsetFrom(this.element,'left',true);
	coords.y1 = this.calcOffsetFrom(this.element,'top',true);
	coords.x2 = coords.x1 + this.w;
	coords.y2 = coords.y1 + this.h;
	return coords;
}
function getElementBoxCoordsById(elementID) {
	var element = document.getElementById(elementID);
	if (element != null) {
		return getElementBoxCoords(element);
	}
}
function getWindowDimensions () {
	var width = (window.innerWidth) ? window.innerWidth : document.body.clientWidth;
	var height = (window.innerHeight) ? window.innerHeight : document.body.clientHeight;
	return new Dimensions(width,height);
}
function getContentDimensions () {
	var width = Math.max(document.body.offsetWidth,document.body.scrollWidth);
	var height = Math.max(document.body.offsetHeight,document.body.scrollHeight);
	return new Dimensions(width,height);
}
function getScrollPosition () {
	var scrollPosition = new XYCoords();
	if (window.scrollX && window.scrollY) {	
		scrollPosition.x = window.scrollX;
		scrollPosition.y = window.scrollY;
	} else {	
		var docBody = document.body;
		var parent_scrollLeft = (docBody.parentNode.scrollLeft) ? docBody.parentNode.scrollLeft : 0;
		var parent_scrollTop = (docBody.parentNode.scrollTop) ? docBody.parentNode.scrollTop : 0;
		scrollPosition.x = Math.max(docBody.scrollLeft,parent_scrollLeft);
		scrollPosition.y = Math.max(docBody.scrollTop,parent_scrollTop);
	}
	return scrollPosition;
}
function defineEventHandler (element,etype,func,trap) {
	if (document.addEventListener) {
		element.addEventListener(etype,func,trap);
	} else if (document.attachEvent) {
		etype = 'on'+etype;
		element.attachEvent(etype,func);
	}
}
var onload_queue = new Array();
function execute_onload () {
	for (var i=0; i < onload_queue.length; i++) {
		onload_queue[i]();
	}
}
function registerOnLoadFunc () {
	for (var i=0; i < arguments.length; i++) {
		if (typeof arguments[i] == 'function') onload_queue[onload_queue.length] = arguments[i];
	}
	if (document.addEventListener || document.attachEvent) {
		var domElement = (window.opera) ? document : window;
		defineEventHandler(domElement,'load',execute_onload,false);
	} else {
		onload = execute_onload;
 	}
}
BrowserDescription = function () {
	this.appN = navigator.appName.toLowerCase();
	this.appV = parseInt(navigator.appVersion);
	this.ua = navigator.userAgent.toLowerCase();
	this.plt = navigator.platform.toLowerCase();
	if (this.ua.indexOf('opera/7') != -1 || this.ua.indexOf('opera 7') != -1) {
		this.appV = 7;
	}
	return this;
}
var browser = new BrowserDescription();